


-- milling support





local enabled = true


do
-- results : [pigment][herb] = numMilled
	local millingResults = {
		[3358] = { -- Khadgar\'s Whisker
			[43105] = 0.985, --Indigo Pigment
			[39339] = 2.965, --Emerald Pigment
		},
		[765] = { -- Silverleaf
			[39151] = 2.467, --Alabaster Pigment
		},
		[8831] = { -- Purple Lotus
			[39340] = 2.499, --Violet Pigment
			[43106] = 0.493, --Ruby Pigment
		},
		[2453] = { -- Bruiseweed
			[43103] = 0.967, --Verdant Pigment
			[39334] = 2.951, --Dusky Pigment
		},
		[13463] = { -- Dreamfoil
			[39341] = 2.499, --Silvery Pigment
			[43107] = 0.498, --Sapphire Pigment
		},
		[13464] = { -- Golden Sansam
			[39341] = 2.499, --Silvery Pigment
			[43107] = 0.503, --Sapphire Pigment
		},
		[13465] = { -- Mountain Silversage
			[39341] = 2.999, --Silvery Pigment
			[43107] = 0.995, --Sapphire Pigment
		},
		[785] = { -- Mageroyal
			[43103] = 0.477, --Verdant Pigment
			[39334] = 2.415, --Dusky Pigment
		},
		[36901] = { -- Goldclover
			[43109] = 0.486, --Icy Pigment
			[39343] = 2.429, --Azure Pigment
		},
		[36903] = { -- Adder\'s Tongue
			[43109] = 1.208, --Icy Pigment
			[39343] = 2.903, --Azure Pigment
		},
		[36905] = { -- Lichbloom
			[43109] = 0.949, --Icy Pigment
			[39343] = 2.87, --Azure Pigment
		},
		[36907] = { -- Talandra\'s Rose
			[43109] = 0.475, --Icy Pigment
			[39343] = 2.389, --Azure Pigment
		},
		[8838] = { -- Sungrass
			[39340] = 2.473, --Violet Pigment
			[43106] = 0.497, --Ruby Pigment
		},
		[4625] = { -- Firebloom
			[39340] = 2.499, --Violet Pigment
			[43106] = 0.494, --Ruby Pigment
		},
		[8839] = { -- Blindweed
			[39340] = 2.975, --Violet Pigment
			[43106] = 0.988, --Ruby Pigment
		},
		[3369] = { -- Grave Moss
			[43104] = 0.485, --Burnt Pigment
			[39338] = 2.467, --Golden Pigment
		},
		[3818] = { -- Fadeleaf
			[43105] = 0.477, --Indigo Pigment
			[39339] = 2.472, --Emerald Pigment
		},
		[22785] = { -- Felweed
			[39342] = 2.941, --Nether Pigment
			[43108] = 0.488, --Ebon Pigment
		},
		[22786] = { -- Dreaming Glory
			[39342] = 2.451, --Nether Pigment
			[43108] = 0.485, --Ebon Pigment
		},
		[22787] = { -- Ragveil
			[39342] = 2.5, --Nether Pigment
			[43108] = 0.491, --Ebon Pigment
		},
		[8845] = { -- Ghost Mushroom
			[39340] = 2.944, --Violet Pigment
			[43106] = 1.016, --Ruby Pigment
		},
		[22790] = { -- Ancient Lichen
			[39342] = 2.937, --Nether Pigment
			[43108] = 0.963, --Ebon Pigment
		},
		[8846] = { -- Gromsblood
			[39340] = 2.971, --Violet Pigment
			[43106] = 0.967, --Ruby Pigment
		},
		[22792] = { -- Nightmare Vine
			[39342] = 3, --Nether Pigment
			[43108] = 1.016, --Ebon Pigment
		},
		[2449] = { -- Earthroot
			[39151] = 2.962, --Alabaster Pigment
		},
		[3355] = { -- Wild Steelbloom
			[43104] = 0.479, --Burnt Pigment
			[39338] = 2.471, --Golden Pigment
		},
		[3820] = { -- Stranglekelp
			[43103] = 0.982, --Verdant Pigment
			[39334] = 2.965, --Dusky Pigment
		},
		[2450] = { -- Briarthorn
			[43103] = 0.475, --Verdant Pigment
			[39334] = 2.947, --Dusky Pigment
		},
		[36904] = { -- Tiger Lily
			[43109] = 0.468, --Icy Pigment
			[39343] = 2.843, --Azure Pigment
		},
		[36906] = { -- Icethorn
			[43109] = 0.956, --Icy Pigment
			[39343] = 2.87, --Azure Pigment
		},
		[3821] = { -- Goldthorn
			[43105] = 0.494, --Indigo Pigment
			[39339] = 2.469, --Emerald Pigment
		},
		[39970] = { -- Fire Leaf
			[39343] = 2.314, --Azure Pigment
		},
		[22791] = { -- Netherbloom
			[39342] = 2.913, --Nether Pigment
			[43108] = 0.975, --Ebon Pigment
		},
		[22789] = { -- Terocone
			[39342] = 2.5, --Nether Pigment
			[43108] = 0.5, --Ebon Pigment
		},
		[22793] = { -- Mana Thistle
			[39342] = 2.954, --Nether Pigment
			[43108] = 0.986, --Ebon Pigment
		},
		[3357] = { -- Liferoot
			[43104] = 0.975, --Burnt Pigment
			[39338] = 2.957, --Golden Pigment
		},
		[3819] = { -- Wintersbite
			[43105] = 0.96, --Indigo Pigment
			[39339] = 2.977, --Emerald Pigment
		},
		[13467] = { -- Icecap
			[39341] = 2.985, --Silvery Pigment
			[43107] = 0.966, --Sapphire Pigment
		},
		[13466] = { -- Plaguebloom
			[39341] = 2.997, --Silvery Pigment
			[43107] = 0.99, --Sapphire Pigment
		},
		[2447] = { -- Peacebloom
			[39151] = 2.96, --Alabaster Pigment
		},
		[2452] = { -- Swiftthistle
			[43103] = 0.481, --Verdant Pigment
			[39334] = 2.96, --Dusky Pigment
		},
		[3356] = { -- Kingsblood
			[43104] = 0.984, --Burnt Pigment
			[39338] = 2.962, --Golden Pigment
		},
		[8836] = { -- Arthas\' Tears
			[39340] = 2.474, --Violet Pigment
			[43106] = 0.511, --Ruby Pigment
		},
		[37921] = { -- Deadnettle
			[43109] = 0.477, --Icy Pigment
			[39343] = 2.397, --Azure Pigment
		},
	}


	local pigmentSources = {}


	local function BuildPigmentSources()
		for herbID, pigmentTable in pairs(millingResults) do
			for pigmentID, count in pairs(pigmentTable) do
				if not pigmentSources[pigmentID] then
					pigmentSources[pigmentID] = {}
				end

				pigmentSources[pigmentID][herbID] = count
			end
		end
	end


	-- spoof recipes for milled herbs -> pigments
	local function AddToRecipeCache()
		for herbID, pigmentTable in pairs(millingResults) do
			local reagentTable = {}
			local recipeName = "Mill "..(GetItemInfo(herbID) or "item:"..herbID)

			reagentTable[herbID] = 5

			LSW:AddRecipe(-herbID, recipeName, pigmentTable, reagentTable, true)
		end
	end



	local function GetMillingSources(itemID)
		return millingResults[itemID]
	end


	local function GetMillingValue(itemID)
		local millingTable = millingResults[itemID]

		local value = 0

		if (millingTable) then
			for pigmentID, count in pairs(millingTable) do
				value = value + (LSW.auctionValue(pigmentID) or 0) * (count or 1)
			end

			return value
		end
	end


	local function GetPigmentSources(itemID)
		return pigmentSources[itemID]
	end



	local function Init()
		LSW:ChatMessage("LilSparky's Workshop adding native Milling support")

		BuildPigmentSources()
		AddToRecipeCache()

		LSW.getMillingValue = GetMillingValue
		LSW.getMillingResults = GetMillingSources
		LSW.getPigmentSources = GetPigmentSources
	end


	local function Test(index)
		if enabled then
			return true
		end

		return false
	end

	LSW:RegisterPricingSupport("Milling", Test, Init)
end


